/* 
 *  This program is an interactive FAQ to ease investigations.
 *  Copyright (C) 2012 Julien Bruguier.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */ 

#ifndef __INVESTIGATION_DONNEES_STATISTIQUES__
#define __INVESTIGATION_DONNEES_STATISTIQUES__

#include <vector>
#include <src/global/global.h>
namespace Investigation { namespace Donnees { DECL_SHARED_PTR(Statistiques); } }

namespace Investigation
{
	namespace Donnees
	{
		class Statistiques
		{
			public:
				typedef enum class {NON_EVALUE,VRAI,FAUX} Resultat;
				Statistiques()
				:_resultat(Resultat::NON_EVALUE) {};
				void operator() (const bool resultat)
				{
					if(_resultat!=Resultat::NON_EVALUE)
						throw;
					_resultat=resultat ? Resultat::VRAI : Resultat::FAUX;
				}
				operator Resultat () const
				{
					return _resultat;
				}
				bool operator==(const Statistiques& statistiques) const
				{
					return _resultat==statistiques._resultat;
				}
				bool operator!=(const Statistiques& statistiques) const
				{
					return _resultat!=statistiques._resultat;
				}
				operator bool () const
				{
					return _resultat==Resultat::VRAI;
				}
			private:
				Resultat _resultat;
		};
	}
}
#endif
